window.localStorage.setItem("auth", 0);
window.localStorage.setItem("auth", 0); // hak ie11

pbxGenerateCodesForSecondFactors = ['Email', 'Sms'];

$(document).ready(function() {
	$("#u").focus();
	$('.google-sign-on').on('click', loadGoogleSignOnUrl);
	$('.office365-sign-on').on('click', loadOffice365SignOnUrl);
	isRememberAllowed();
});

function auth(isTwoFactor) {
	isTwoFactor

	var data = {
			remember: +$("#remember").is(':checked')
	}

	var error = false;

	if(isTwoFactor){
		data['type'] = 'next';
		data['code'] = $("#code").val();
		if(data['code'] == ''){
			$("#code").addClass('error');
			error = true;
		}
	}else{
		data['login'] = $("#u").val();
		data['password'] = $("#p").val();

		if(data['login'] == ''){
			$("#u").addClass('error');
			error = true;
		}

		if(data['password'] == ''){
			$("#p").addClass('error');
			error = true;
		}
	}

	if(error){
		return false;
	}

	sendLoginRequest(data);

	return false;
}

function showTwoFactorForm(secondFactor){
    if (pbxGenerateCodesForSecondFactors.indexOf(secondFactor) === -1) {
        $('form.twoFactorForm').removeClass('with-timer');
        $('form.twoFactorForm > .description').text('To log in, use the confirmation code generated by the mobile application.');
	} else {
    	$('form.twoFactorForm').addClass('with-timer');
        $('form.twoFactorForm > .description').text('To log in, use the confirmation code sent to you.');

        var CountDown = function(element) {
            this._element = (element instanceof Element) ? $(element) : element;
            this._timer = null;
            this._controlReset = $('<div/>').attr('title', 'Resend authentication code').addClass('controlReset').addClass('fa').addClass('fa-reply');

            this.load = function() {
                this._controlReset.on('click', this._reload.bind(this));
                this._startTimer();
            };

            this._reload = function() {
                if (this._timer === null) {
                    return;
                }

                this._resendAuthenticationCode();

                this._controlReset.detach();
                this._timer.start();
            };

            this._startTimer = function() {
                var self = this;
                var countdownOptions = {
                    radius: 20,
                    seconds: 180,
                    fontColor: '#000000',
                    strokeStyle: '#1e76cb',
                    fillStyle: '#f5f5f5',
                    fontSize: 18,
                    strokeWidth: 2,
                    smooth: true,
                    label: false,
                    autostart: false,
                    onComplete: self._showControls.bind(self)
                };

                this._timer = this._element.countdown360(countdownOptions);
                this._timer.start();
            };

            this._showControls = function() {
                this._element.append(this._controlReset);
            };

            this._resendAuthenticationCode = function() {
            	$.post('/api/v1/personal/settings/TwoFactor/' + secondFactor + '/Code/');
			};
        };

        var countdown = new CountDown($('.countdown'));
        countdown.load();
	}

    $('form.authForm').hide();
    $('form.twoFactorForm').show();
	$("#code").focus();
}

function sendLoginRequest(data){
	$('.box input.error').removeClass('error');

	$('.box').mask('Loading...');

	$.ajax({
		type: 'POST',
		url: '../api/v1/personal/login',
		data: data,
		success: function(data, textStatus, jqXHR){
			$('#error').html("");
			if(data && data.type == 'result' ){
				if(data.result == 'OK'){
					window.location = location.search.replace(/^\?/, '..') ? location.search.replace(/^\?/, '..') : '../';
				}else if(data.result['next']){
					$('.box').unmask();
					showTwoFactorForm(data.result['next']);
				}
			}

		},
		error: function(jqXHR, textStatus, errorThrown){
			$('.box').unmask();
			var response = JSON.parse(jqXHR.responseText);
			if(response.type == 'error' && response.reason && response.reason!=''){
				$('#error').html(response.reason);
			}
		},
		complete: function(jqXHR, textStatus){

		}
	});
}

function callbackGoogleSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('#error').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#u").val(data.userInfo.email);
			$("#p").val('');

			var login = $("#u").val();

			var error = false;
			if(login == ''){
				$("#u").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'google',
				login: login,
				remember: +$("#remember").is(':checked'),
				token: data.token
			});
		}
	}
}


function callbackMicrosoftSingleSignOn(data){
	if(data){
		if(data.error && data.error_description){
			$('#error').html(data.error_description);
		}else if(data.token && data.userInfo){
			$("#u").val(data.userInfo.preferred_username);
			$("#p").val('');

			var login = $("#u").val();

			var error = false;
			if(login == ''){
				$("#u").addClass('error');
				error = true;
			}

			if(error){
				return false;
			}

			sendLoginRequest({
				type: 'microsoft',
				login: login,
				remember: +$("#remember").is(':checked'),
				token: data.token
			});
		}
	}
}

function loadOffice365SignOnUrl(){
	window.open(
			'../api/Microsoft/SingleSignOn/?callback=callbackMicrosoftSingleSignOn',
			"Windows sing on",
			"location=0,status=0,scrollbars=0,width=800,height=500"
			);
}

function loadGoogleSignOnUrl(){
	window.open(
			'../api/Google/SingleSignOn/?callback=callbackGoogleSingleSignOn',
			"Google sing on",
			"location=0,status=0,scrollbars=0,width=800,height=500"
			);
}

function isRememberAllowed(){
	if(location.protocol !== 'https:'){
		$('#remember').attr('disabled', true);
	}
}
